// RMI server

import java.rmi.*;
import java.rmi.server.*;

public class ConferenceServerImpl extends UnicastRemoteObject implements
        ConferenceServer {

    static Program prog[];

    // Costruttore
    public ConferenceServerImpl() throws RemoteException {
        super();
    }

    // Richiede una prenotazione
    public boolean register(int day, String session, String speaker)
            throws RemoteException {
        int numSess = -1;
        System.out.println("RMI server: registration request");
        System.out.println("day     = " + day);
        System.out.println("session = " + session);
        System.out.println("speaker = " + speaker);

        if (session.equals("S1")) {
            numSess = 0;
        } else if (session.equals("S2")) {
            numSess = 1;
        } else if (session.equals("S3")) {
            numSess = 2;
        } else if (session.equals("S4")) {
            numSess = 3;
        } else if (session.equals("S5")) {
            numSess = 4;
        } else if (session.equals("S6")) {
            numSess = 5;
        } else if (session.equals("S7")) {
            numSess = 6;
        } else if (session.equals("S8")) {
            numSess = 7;
        } else if (session.equals("S9")) {
            numSess = 8;
        } else if (session.equals("S10")) {
            numSess = 9;
        } else if (session.equals("S11")) {
            numSess = 10;
        } else if (session.equals("S12")) {
            numSess = 11;
        }

        // If the session number is invalid, raise an exception
        if (numSess == -1) {
            throw new RemoteException();
        }
        if (day < 1 || day > 3) {
            throw new RemoteException();
        }

        return prog[day - 1].register(numSess, speaker);
    }

    // Ritorno il campo
    public Program getProgram(int giorno) throws RemoteException {
        System.out.println("RMI server: requested day  " + giorno + " program");
        return prog[giorno - 1];
    }

    // start RMI server
    public static void main(String[] args) {

        // create programs for 3 days
        prog = new Program[3];
        for (int i = 0; i < 3; i++) {
            prog[i] = new Program();
        }
        final int REGISTRYPORT = 1099;
        String registryHost = "localhost";
        String serviceName = "ConferenceServer";

        // Registrazione del servizio RMI
        String completeName = "//" + registryHost + ":" + REGISTRYPORT + "/" + serviceName;
        try {
            ConferenceServerImpl serverRMI = new ConferenceServerImpl();
            Naming.rebind(completeName, serverRMI);
            System.out.println("RMI server: Service \"" + serviceName+ "\" registered");
        } catch (Exception e) {
            System.err.println("RMI server \"" + serviceName + "\": " + e.getMessage());
            e.printStackTrace();
            System.exit(1);
        }
    }
}
