/* Class that implements a progra for one conference day.
   It must implement the serializable interface because
   it will be returned as result by the RMI server
 */

import java.io.*;

public class Program implements Serializable {

    public String speaker[][] = new String[12][5];

    public Program() {
        for (int i = 0; i < 5; i++) {
            for (int e = 0; e < 12; e++) {
                speaker[e][i] = "";
            }
        }
    }

    /* return true if successful, else false
     */
    public synchronized boolean register(int sessione, String nome) {
        System.out.println("Program: trying to register " + nome
                + " for session " + (sessione + 1));

        for (int k = 0; k < 5; k++) {
            if (speaker[sessione][k].equals("")) {
                speaker[sessione][k] = nome;
                return true;
            }
        }
        return false;
    }

    public void print() {
        System.out.println("Sessione\tPresentation 1\tPresentation 2\tPresentation 3\tPresentation 4\tPresentation 5\n");
        for (int k = 0; k < 12; k++) {
            String line = "S" + (k + 1);
            for (int j = 0; j < 5; j++) {
                line = line + "\t\t" + speaker[k][j];
            }
            System.out.println(line);

        }

    }
}
